/*
 * Copyright © 2011 Linaro Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies
 * and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of
 * Linaro Ltd. not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 * Linaro Ltd. makes no representations about the suitability of this
 * software for any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * LINARO LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
 * NO EVENT SHALL LINARO LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Travis Watkins <travis.watkins@linaro.org>
 */

#ifndef _VERTEXBUFFER_PRIVATE_H
#define _VERTEXBUFFER_PRIVATE_H

#ifdef USE_GLES
#include <GLES2/gl2.h>
#else
#include <GL/gl.h>
#endif

#include <opengl/program.h>

class GLVertexBuffer;

class PrivateVertexBuffer
{
    public:
	PrivateVertexBuffer ();
	~PrivateVertexBuffer ();

	int render (const GLMatrix            &projection,
	            const GLMatrix            &modelview,
	            const GLWindowPaintAttrib &attrib);
	int legacyRender (const GLMatrix            &projection,
	                  const GLMatrix            &modelview,
	                  const GLWindowPaintAttrib &attrib);

    public:
	static GLVertexBuffer *streamingBuffer;
	static GLProgram *genericProgram;

	std::vector<GLfloat> vertexData;
	std::vector<GLfloat> normalData;
	std::vector<GLfloat> colorData;
	std::vector<std::vector<GLfloat> > textureData;

	GLProgram *customProgram;
	GLenum primitiveType;
	GLenum usage;

	GLuint vertexBuffer;
	GLuint normalBuffer;
	GLuint colorBuffer;
	std::vector<GLuint> textureBuffers;
};

#endif //_VERTEXBUFFER_PRIVATE_H

